/* -*- Mode: C; c-file-style: "stroustrup"; -*- */

#include "nxpcanvasmisc.h"

gboolean
_nxp_boolean_handled_accumulator(GSignalInvocationHint *ihint, 
				 GValue                *return_accu, 
				 const GValue          *handler_return, 
				 gpointer               dummy)
{
    gboolean continue_emission;
    gboolean signal_handled;

    signal_handled = g_value_get_boolean(handler_return);
    g_value_set_boolean(return_accu, signal_handled);
    continue_emission = !signal_handled;

    return continue_emission;
}


gboolean
_nxp_object_handled_accumulator(GSignalInvocationHint *ihint, 
				GValue                *return_accu, 
				const GValue          *handler_return, 
				gpointer               dummy)
{
    gboolean  continue_emission;
    GObject  *handler_ret_obj;

    handler_ret_obj = g_value_get_object(handler_return);
    g_value_set_object(return_accu, handler_ret_obj);
    continue_emission = (handler_ret_obj == NULL);

    return continue_emission;
}

