/* -*- Mode: C; c-file-style: "bsd"; -*- */
#ifndef __NXP_CANVAS_TEXT_CURSOR_H__
#define __NXP_CANVAS_TEXT_CURSOR_H__

#include <glib-object.h>
#include "nxpcanvasoverlay.h"


#define NXP_CANVAS_TEXT_CURSOR(object)            (G_TYPE_CHECK_INSTANCE_CAST ((object),\
				nxp_canvas_text_cursor_get_type(), NxpCanvasTextCursor))

#define NXP_CANVAS_TEXT_CURSOR_CLASS(klass)	     (G_TYPE_CHECK_CLASS_CAST ((klass),\
				nxp_canvas_text_cursor_get_type(), NxpCanvasTextCursorClass))

#define NXP_IS_CANVAS_TEXT_CURSOR(object)         (G_TYPE_CHECK_INSTANCE_TYPE ((object),\
				nxp_canvas_text_cursor_get_type()))

#define NXP_IS_CANVAS_TEXT_CURSOR_CLASS(klass)    (G_TYPE_CHECK_CLASS_TYPE ((klass),\
				nxp_canvas_text_cursor_get_type()))

#define NXP_CANVAS_TEXT_CURSOR_GET_CLASS(object)  (G_TYPE_INSTANCE_GET_CLASS ((object),\
				nxp_canvas_text_cursor_get_type(), NxpCanvasTextCursorClass))

#define NXP_CANVAS_TEXT_CURSOR_TYPE(object)       (G_TYPE_FROM_INSTANCE (object))
#define NXP_CANVAS_TEXT_CURSOR_TYPE_NAME(object)  (g_type_name (NXP_CANVAS_TEXT_CURSOR_TYPE (object)))
#define NXP_CANVAS_TEXT_CURSOR_CLASS_TYPE(klass)  (G_TYPE_FROM_CLASS (klass))
#define NXP_CANVAS_TEXT_CURSOR_CLASS_NAME(klass)  (g_type_name (NXP_CANVAS_TEXT_CURSOR_CLASS_TYPE (klass)))

#define NXP_TYPE_CANVAS_TEXT_CURSOR    (nxp_canvas_text_cursor_get_type())


typedef struct _NxpCanvasTextCursor NxpCanvasTextCursor;
typedef struct _NxpCanvasTextCursorClass NxpCanvasTextCursorClass;


struct _NxpCanvasTextCursor
{
    NxpCanvasOverlay overlay;
    GdkLineStyle line_style;
    gint width;
    gint delay;
    GdkPoint p1, p2;
    guint timeout_id;
    gboolean active:1;
    gboolean ghost:1;
};


struct _NxpCanvasTextCursorClass
{
    NxpCanvasOverlayClass base;

};


GType nxp_canvas_text_cursor_get_type    (void);
void  nxp_canvas_text_cursor_start_blink (NxpCanvasTextCursor *self);
void  nxp_canvas_text_cursor_stop_blink  (NxpCanvasTextCursor *self);


#endif /* __NXP_CANVAS_TEXT_CURSOR_H__ */
