/* -*- Mode: C; c-file-style: "stroustrup"; -*- */
#ifndef __NXPLOT_ARTFT_FONT_H__
#define __NXPLOT_ARTFT_FONT_H__

#include <glib.h>
#include <freetype/config/ftheader.h>
#include FT_TYPES_H
#include FT_FREETYPE_H
#include FT_GLYPH_H
#include FT_BBOX_H
#include FT_RENDER_H
#include FT_ERRORS_H
#include FT_SYSTEM_H
#include FT_IMAGE_H


typedef struct _NxplotArtftFont        NxplotArtftFont;
typedef struct _NxplotArtftCachedGlyph NxplotArtftCachedGlyph;

struct _NxplotArtftCachedGlyph {
    guint            refcount;
    FT_Glyph         glyph;
    gint             index;
    NxplotArtftFont *font;
};



G_BEGIN_DECLS

void                    nxplot_artft_font_init          (void);
/* transf is a libart_lgpl format affine matrix */
NxplotArtftFont*        nxplot_artft_get_font           (GQuark                  name,
							 double const           *transf);
void                    nxplot_artft_font_unref         (NxplotArtftFont        *font);
void                    nxplot_artft_font_get_transf    (NxplotArtftFont        *font,
							 FT_Matrix              *out_transf);
NxplotArtftCachedGlyph* nxplot_artft_font_get_glyph     (NxplotArtftFont        *font,
							 gunichar                code);
void                    nxplot_artft_cached_glyph_unref (NxplotArtftCachedGlyph *glyph);
FT_Face                 nxplot_artft_font_get_face      (NxplotArtftFont        *font);
gchar**                 nxplot_artft_list_fonts         (void);


G_END_DECLS

#endif /* __NXPLOT_ARTFT_FONT_H__ */

