/* -*- Mode: C; c-file-style: "stroustrup"; -*- */

#include "nxplot.h"
#include <math.h>

enum {
  TEXT_ENTERED, 
  LAST_SIGNAL
};

enum {
    PROP_0, 
    PROP_ECHO_TAG, 
    PROP_RESULT_TAG
};


/*  static guint signals[LAST_SIGNAL] = { 0 }; */
static NxplotClass *nxplot_class = NULL;


static void nxplot_init            (Nxplot       *instance,
				    gpointer      g_class);
static void nxplot_class_base_init (NxplotClass  *class);
static void nxplot_class_init      (NxplotClass  *class,
				    gpointer      data);
static void nxplot_set_property    (GObject      *object,
				    guint         prop_id,
				    const GValue *value,
				    GParamSpec   *pspec);
static void nxplot_get_property    (GObject      *object,
				    guint         prop_id,
				    GValue       *value,
				    GParamSpec   *pspec);
static void nxplot_shutdown        (GObject      *object);






static GTypeInfo typeinfo = 
{
    /* interface types, classed types, instantiated types */
    sizeof(NxplotClass), 

    (GBaseInitFunc)nxplot_class_base_init, 
    NULL, // GBaseFinalizeFunc      base_finalize;

    /* classed types, instantiated types */
    (GClassInitFunc)nxplot_class_init, 
    NULL, // GClassFinalizeFunc     class_finalize;
    NULL, // gconstpointer          class_data;

    /* instantiated types */
    sizeof(Nxplot),		//guint16                instance_size;
    0,					//guint16                n_preallocs;
    (GInstanceInitFunc)nxplot_init, //GInstanceInitFunc      instance_init;

    /* value handling */
    NULL,				//const GTypeValueTable	*value_table;
};



GType nxplot_get_type(void)
{
    static GType type = 0;
    if (!type)
    {
	type = g_type_register_static(G_TYPE_OBJECT, "Nxplot",
				      &typeinfo, 0);
    }
    return type;
}




static void nxplot_init(Nxplot *self, gpointer g_class)
{
    if (!nxplot_class)
	nxplot_class = NXPLOT_GET_CLASS(self);
    self->opened = FALSE;
}

static void nxplot_class_base_init(NxplotClass *class)
{
    /* empty */
}

static void nxplot_class_init(NxplotClass *class, gpointer data)
{
    GObjectClass *object_class = G_OBJECT_CLASS(class);

    object_class->set_property = nxplot_set_property;
    object_class->get_property = nxplot_get_property;
    object_class->finalize = nxplot_shutdown;

/*      g_object_class_install_property(object_class, */
/*  				    PROP_ECHO_TAG, */
/*  				    g_param_spec_object( */
/*  					"echo-tag", "Echo tag", */
/*  					"GtkTextTag to apply to echoed text", */
/*  					GTK_TYPE_TEXT_TAG, */
/*  					G_PARAM_WRITABLE)); */


/*      class->text_entered = nxplot_text_entered; */
/*      signals[TEXT_ENTERED] = class->text_entered_signal =  */
/*  	g_signal_newc("text-entered", */
/*  		      NXPLOT_CLASS_TYPE(class), */
/*  		      G_SIGNAL_RUN_LAST, */
/*  		      GTK_SIGNAL_OFFSET(NxplotClass, text_entered), */
/*  		      NULL, NULL, g_cclosure_marshal_VOID__STRING, */
/*  		      G_TYPE_NONE, 1, G_TYPE_STRING); */

}


static void
nxplot_set_property(GObject      *object, 
                           guint         prop_id, 
                           const GValue *value, 
                           GParamSpec   *pspec)
{
    Nxplot *self;

    self = NXPLOT(object);

    switch (prop_id)
    {

/*      case PROP_ECHO_TAG: { */
/*  	GtkTextTag *tag; */
/*  	GtkTextTagTable *table; */
/*  	GValue *val; */
/*  	gchar *str = NULL; */
/*  	tag = GTK_TEXT_TAG(g_value_get_object(value)); */
/*  	table = gtk_text_buffer_get_tag_table(gtk_text_view_get_buffer( */
/*  	    GTK_TEXT_VIEW(self->text_view))); */
/*  	g_object_set(tag, "name", "console-view-echo", NULL); */
/*  	gtk_text_tag_table_install(table, tag); */
/*  	tag = gtk_text_tag_table_lookup(table, "console-view-echo"); */
/*  	g_assert(tag); */
/*  	gtk_text_tag_set_priority(tag, 0); */
/*  	break; */
/*      } */


    default:
      G_OBJECT_WARN_INVALID_PROPERTY_ID(object, prop_id, pspec);
      break;
    }

}


static void
nxplot_get_property(GObject      *object, 
                           guint         prop_id, 
                           GValue       *value, 
                           GParamSpec   *pspec)
{
    Nxplot *self;

    self = NXPLOT(object);

    switch (prop_id)
    {

    default:
      G_OBJECT_WARN_INVALID_PROPERTY_ID(object, prop_id, pspec);
      break;
    }

}





static void nxplot_shutdown(GObject *object)
{
/*      Nxplot *self = NXPLOT(object); */
/*      g_message(__FUNCTION__); */
}


void nxplot_open(Nxplot *nxplot)
{
    NxplotClass *class;
    g_return_if_fail(nxplot);
    g_return_if_fail(IS_NXPLOT(nxplot));
    class = NXPLOT_GET_CLASS(nxplot);
    if (class->open)
	class->open(nxplot);
    else
	g_warning("open method not implemented by driver");

}


void nxplot_close(Nxplot *nxplot)
{
    NxplotClass *class;
    g_return_if_fail(nxplot);
    g_return_if_fail(IS_NXPLOT(nxplot));
    class = NXPLOT_GET_CLASS(nxplot);
    if (class->close)
	class->close(nxplot);
    else
	g_warning("close method not implemented by driver");
}


void nxplot_endpath(Nxplot *nxplot)
{
    NxplotClass *class;
    g_return_if_fail(nxplot);
    g_return_if_fail(IS_NXPLOT(nxplot));
    class = NXPLOT_GET_CLASS(nxplot);
    if (class->endpath)
	class->endpath(nxplot);
    else
	g_warning("endpath method not implemented by driver");
}


void nxplot_erase(Nxplot *nxplot)
{
    NxplotClass *class;
    g_return_if_fail(nxplot);
    g_return_if_fail(IS_NXPLOT(nxplot));
    class = NXPLOT_GET_CLASS(nxplot);
    if (class->erase)
	class->erase(nxplot);
    else
	g_warning("erase method not implemented by driver");

}

void nxplot_clearrect(Nxplot *nxplot, double x1, double y1, double x2, double y2)
{
    NxplotClass *class;
    g_return_if_fail(nxplot);
    g_return_if_fail(IS_NXPLOT(nxplot));
    class = NXPLOT_GET_CLASS(nxplot);
    if (class->clearrect)
	class->clearrect(nxplot, x1, y1, x2, y2);
    else
	g_warning("clearrect method not implemented by driver");
}


void nxplot_line(Nxplot *nxplot, double x1, double y1, double x2, double y2)
{
    NxplotClass *class;
    g_return_if_fail(nxplot);
    g_return_if_fail(IS_NXPLOT(nxplot));
    class = NXPLOT_GET_CLASS(nxplot);
    if (class->line)
	class->line(nxplot, x1, y1, x2, y2);
    else
	g_warning("line method not implemented by driver");
}


void nxplot_space(Nxplot *nxplot, double x1, double y1, double x2, double y2)
{
    NxplotClass *class;
    g_return_if_fail(nxplot);
    g_return_if_fail(IS_NXPLOT(nxplot));
    class = NXPLOT_GET_CLASS(nxplot);
    if (class->space)
	class->space(nxplot, x1, y1, x2, y2);
    else
	g_warning("space method not implemented by driver");
}


void nxplot_linerel(Nxplot *nxplot, double x1, double y1, double x2, double y2)
{
    NxplotClass *class;
    g_return_if_fail(nxplot);
    g_return_if_fail(IS_NXPLOT(nxplot));
    class = NXPLOT_GET_CLASS(nxplot);
    if (class->linerel)
	class->linerel(nxplot, x1, y1, x2, y2);
    else
	g_warning("linerel method not implemented by driver");

}


void nxplot_linewidth(Nxplot *nxplot, double width)
{
    NxplotClass *class;
    g_return_if_fail(nxplot);
    g_return_if_fail(IS_NXPLOT(nxplot));
    class = NXPLOT_GET_CLASS(nxplot);
    if (class->linewidth)
	class->linewidth(nxplot, width);
    else
	g_warning("linewidth method not implemented by driver");

}


void nxplot_pencolor(Nxplot *nxplot, guint16 red, guint16 green, guint16 blue)
{
    NxplotClass *class;
    g_return_if_fail(nxplot);
    g_return_if_fail(IS_NXPLOT(nxplot));
    class = NXPLOT_GET_CLASS(nxplot);
    if (class->pencolor)
	class->pencolor(nxplot, red, green, blue);
    else
	g_warning("pencolor method not implemented by driver");
}


void nxplot_bgcolor(Nxplot *nxplot, guint16 red, guint16 green, guint16 blue)
{
    NxplotClass *class;
    g_return_if_fail(nxplot);
    g_return_if_fail(IS_NXPLOT(nxplot));
    class = NXPLOT_GET_CLASS(nxplot);
    if (class->bgcolor)
	class->bgcolor(nxplot, red, green, blue);
    else
	g_warning("bgcolor method not implemented by driver");
}


void nxplot_pencolorname(Nxplot *nxplot, const char *name)
{
    NxplotClass *class;
    g_return_if_fail(nxplot);
    g_return_if_fail(IS_NXPLOT(nxplot));
    class = NXPLOT_GET_CLASS(nxplot);
    if (class->pencolorname)
	class->pencolorname(nxplot, name);
    else
	g_warning("pencolorname method not implemented by driver");

}



void nxplot_move(Nxplot *nxplot, double x, double y)
{
    NxplotClass *class;
    g_return_if_fail(nxplot);
    g_return_if_fail(IS_NXPLOT(nxplot));
    class = NXPLOT_GET_CLASS(nxplot);
    if (class->move)
	class->move(nxplot, x, y);
    else
	g_warning("move method not implemented by driver");
}


void nxplot_circle(Nxplot *nxplot, double xc, double yc, double r)
{
    NxplotClass *class;
    g_return_if_fail(nxplot);
    g_return_if_fail(IS_NXPLOT(nxplot));
    class = NXPLOT_GET_CLASS(nxplot);
    if (class->circle)
	class->circle(nxplot, xc, yc, r);
    else
	g_warning("circle method not implemented by driver");
}


void nxplot_moverel(Nxplot *nxplot, double x, double y)
{
    NxplotClass *class;
    g_return_if_fail(nxplot);
    g_return_if_fail(IS_NXPLOT(nxplot));
    class = NXPLOT_GET_CLASS(nxplot);
    if (class->moverel)
	class->moverel(nxplot, x, y);
    else
	g_warning("moverel method not implemented by driver");
}


void nxplot_fontname(Nxplot *nxplot, const char *font_name)
{
    NxplotClass *class;
    g_return_if_fail(nxplot);
    g_return_if_fail(IS_NXPLOT(nxplot));
    class = NXPLOT_GET_CLASS(nxplot);
    if (class->fontname)
	class->fontname(nxplot, font_name);
    else
	g_warning("fontname method not implemented by driver");
}


void nxplot_listfonts(Nxplot *nxplot, gchar ***fontnames)
{
    NxplotClass *class;
    g_return_if_fail(nxplot);
    g_return_if_fail(IS_NXPLOT(nxplot));
    class = NXPLOT_GET_CLASS(nxplot);
    if (class->listfonts)
	class->listfonts(nxplot, fontnames);
    else {
	g_warning("list_fonts method not implemented by driver");
	*fontnames = NULL;
    }
}


void nxplot_fontsize(Nxplot *nxplot, double size)
{
    NxplotClass *class;
    g_return_if_fail(nxplot);
    g_return_if_fail(IS_NXPLOT(nxplot));
    class = NXPLOT_GET_CLASS(nxplot);
    if (class->fontsize)
	class->fontsize(nxplot, size);
    else
	g_warning("fontsize method not implemented by driver");
}


void nxplot_textangle(Nxplot *nxplot, double angle)
{
    NxplotClass *class;
    g_return_if_fail(nxplot);
    g_return_if_fail(IS_NXPLOT(nxplot));
    class = NXPLOT_GET_CLASS(nxplot);
    if (class->textangle)
	class->textangle(nxplot, angle);
    else
	g_warning("textangle method not implemented by driver");

}


void nxplot_linemode(Nxplot *nxplot, NxplotLinemode mode)
{
    NxplotClass *class;
    g_return_if_fail(nxplot);
    g_return_if_fail(IS_NXPLOT(nxplot));
    class = NXPLOT_GET_CLASS(nxplot);
    if (class->linemode)
	class->linemode(nxplot, mode);
    else
	g_warning("linemode method not implemented by driver");
}


void nxplot_label(Nxplot *nxplot, NxplotHAlign halign, NxplotVAlign valign, 
		  const char *text)
{
    NxplotClass *class;
    g_return_if_fail(nxplot);
    g_return_if_fail(IS_NXPLOT(nxplot));
    class = NXPLOT_GET_CLASS(nxplot);
    if (class->label)
	class->label(nxplot, halign, valign, text);
    else
	g_warning("label method not implemented by driver");

}


double nxplot_labelwidth(Nxplot *nxplot, const char *text)
{
    NxplotClass *class;
    g_return_val_if_fail(nxplot, -1);
    g_return_val_if_fail(IS_NXPLOT(nxplot), -1);
    class = NXPLOT_GET_CLASS(nxplot);
    if (class->labelwidth)
	return class->labelwidth(nxplot, text);
    else
	g_warning("labelwidth method not implemented by driver");
    return 0;
}


double nxplot_descender(Nxplot *nxplot)
{
    NxplotClass *class;
    g_return_val_if_fail(nxplot, -1);
    g_return_val_if_fail(IS_NXPLOT(nxplot), -1);
    class = NXPLOT_GET_CLASS(nxplot);
    if (class->descender)
	return class->descender(nxplot);
    else
	g_warning("descender method not implemented by driver");
    return 0;
}


void nxplot_savestate(Nxplot *nxplot)
{
    NxplotClass *class;
    g_return_if_fail(nxplot);
    g_return_if_fail(IS_NXPLOT(nxplot));
    class = NXPLOT_GET_CLASS(nxplot);
    if (class->savestate)
	class->savestate(nxplot);
    else
	g_warning("savestate method not implemented by driver");
}


void nxplot_restorestate(Nxplot *nxplot)
{
    NxplotClass *class;
    g_return_if_fail(nxplot);
    g_return_if_fail(IS_NXPLOT(nxplot));
    class = NXPLOT_GET_CLASS(nxplot);
    if (class->restorestate)
	class->restorestate(nxplot);
    else
	g_warning("restorestate method not implemented by driver");

}


void nxplot_setmatrix(Nxplot *nxplot, double m0, double m1,
		      double m2, double m3, double tx, double ty)
{
    NxplotClass *class;
    g_return_if_fail(nxplot);
    g_return_if_fail(IS_NXPLOT(nxplot));
    class = NXPLOT_GET_CLASS(nxplot);
    if (class->setmatrix)
	class->setmatrix(nxplot, m0, m1, m2, m3, tx, ty);
    else
	g_warning("setmatrix method not implemented by driver");

}


void nxplot_concat(Nxplot *nxplot, double m0, double m1,
		   double m2, double m3, double tx, double ty)
{
    NxplotClass *class;
    g_return_if_fail(nxplot);
    g_return_if_fail(IS_NXPLOT(nxplot));
    class = NXPLOT_GET_CLASS(nxplot);
    if (class->concat)
	class->concat(nxplot, m0, m1, m2, m3, tx, ty);
    else
	g_warning("concat method not implemented by driver");
}


void nxplot_rotate(Nxplot *nxplot, double theta)
{
    NxplotClass *class;
    g_return_if_fail(nxplot);
    g_return_if_fail(IS_NXPLOT(nxplot));
    class = NXPLOT_GET_CLASS(nxplot);
    if (class->rotate)
	class->rotate(nxplot, theta);
    else
	g_warning("rotate method not implemented by driver");
}


void nxplot_scale(Nxplot *nxplot, double sx, double sy)
{
    NxplotClass *class;
    g_return_if_fail(nxplot);
    g_return_if_fail(IS_NXPLOT(nxplot));
    class = NXPLOT_GET_CLASS(nxplot);
    if (class->scale)
	class->scale(nxplot, sx, sy);
    else
	g_warning("scale method not implemented by driver");
}


void nxplot_translate(Nxplot *nxplot, double tx, double ty)
{
    NxplotClass *class;
    g_return_if_fail(nxplot);
    g_return_if_fail(IS_NXPLOT(nxplot));
    class = NXPLOT_GET_CLASS(nxplot);
    if (class->translate)
	class->translate(nxplot, tx, ty);
    else
	g_warning("translate method not implemented by driver");
}


void nxplot_space2window(Nxplot *nxplot, double x, double y, double *wx, double *wy)
{
    NxplotClass *class;
    g_return_if_fail(nxplot);
    g_return_if_fail(IS_NXPLOT(nxplot));
    class = NXPLOT_GET_CLASS(nxplot);
    if (class->space2window)
	class->space2window(nxplot, x, y, wx, wy);
    else
	g_warning("space2window method not implemented by driver");
}


void nxplot_window2space(Nxplot *nxplot, double wx, double wy, double *x, double *y)
{
    NxplotClass *class;
    g_return_if_fail(nxplot);
    g_return_if_fail(IS_NXPLOT(nxplot));
    class = NXPLOT_GET_CLASS(nxplot);
    if (class->window2space)
	class->window2space(nxplot, wx, wy, x, y);
    else
	g_warning("window2space method not implemented by driver");
}




gboolean nxplot_rect_intersect(NxplotRect *src1, NxplotRect *src2, NxplotRect *dest)
{
    gint dest_x, dest_y;
    gint dest_w, dest_h;
    gint return_val;

    g_return_val_if_fail (src1 != NULL, FALSE);
    g_return_val_if_fail (src2 != NULL, FALSE);
    g_return_val_if_fail (dest != NULL, FALSE);

    return_val = FALSE;

    dest_x = MAX (src1->x1, src2->x1);
    dest_y = MAX (src1->y1, src2->y1);
    dest_w = MIN (src1->x2, src2->x2) - dest_x;
    dest_h = MIN (src1->y2, src2->y2) - dest_y;

    if (dest_w > 0 && dest_h > 0) {
	dest->x1 = dest_x;
	dest->y1 = dest_y;
	dest->x2 = dest_x + dest_w;
	dest->y2 = dest_y + dest_h;
	return_val = TRUE;
    } else {
	dest->x1 = dest->x2 = dest_x;
	dest->y1 = dest->y2 = dest_y;
    }

    return return_val;
}


void nxplot_rect_space2window(Nxplot *pl, NxplotRect *srect,
			      GdkRectangle *wrect)
{
    NxplotPoint sp1, sp2;
    double wp1_x, wp1_y, wp2_x, wp2_y, t;
    gint x1, y1, x2, y2;
    sp1.x = srect->x1;
    sp1.y = srect->y1;
    sp2.x = srect->x2;
    sp2.y = srect->y2;
    nxplot_space2window(pl, sp1.x, sp1.y, &wp1_x, &wp1_y);
    nxplot_space2window(pl, sp2.x, sp2.y, &wp2_x, &wp2_y);
    if (wp1_x > wp2_x) {t = wp1_x; wp1_x = wp2_x; wp2_x = t;}
    if (wp1_y > wp2_y) {t = wp1_y; wp1_y = wp2_y; wp2_y = t;}
    x1 = wp1_x; y1 = wp1_y;
    x2 = wp2_x; y2 = wp2_y;
    wrect->x = x1;
    wrect->y = y1;
    wrect->width = x2 - x1 + 1;
    wrect->height = y2 - y1 + 1;
}



void nxplot_rect_window2space(Nxplot *pl, GdkRectangle *wrect,
			      NxplotRect *srect)
{
    double wp1_x, wp1_y, wp2_x, wp2_y, t;
    wp1_x = wrect->x + .5;
    wp1_y = wrect->y + .5;
    wp2_x = wrect->x + wrect->width - 1 + .5;
    wp2_y = wrect->y + wrect->height - 1 + .5;
    nxplot_window2space(pl, wp1_x, wp1_y, &srect->x1, &srect->y1);
    nxplot_window2space(pl, wp2_x, wp2_y, &srect->x2, &srect->y2);
    if (srect->x1 > srect->x2) {t = srect->x1; srect->x1 = srect->x2; srect->x2 = t;}
    if (srect->y1 > srect->y2) {t = srect->y1; srect->y1 = srect->y2; srect->y2 = t;}
}



void nxplot_vec_space2window(Nxplot *pl, NxplotVec *svec, NxplotVec *wvec)
{
    NxplotPoint sp1, sp2, origin;
    sp1.x = svec->x;
    sp1.y = svec->y;
    sp2.x = 0;
    sp2.y = 0;
    nxplot_space2window(pl, sp1.x, sp1.y, &wvec->x, &wvec->y);
    nxplot_space2window(pl, sp2.x, sp2.y, &origin.x, &origin.y);
    wvec->x -= origin.x;
    wvec->y -= origin.y;
}

/* --- NxplotRect boxed type --- */

NxplotRect* nxplot_rect_copy(NxplotRect *rect)
{
    NxplotRect *nr;
    nr = g_new(NxplotRect, 1);
    *nr = *rect;
    return nr;
}

void nxplot_rect_free(NxplotRect *rect)
{
    g_free(rect);
}

GType nxplot_rect_get_type(void)
{
    static GType type = 0;
    
    if (type == 0)
	type = g_boxed_type_register_static("NxplotRect",
					    (GBoxedCopyFunc) nxplot_rect_copy,
					    (GBoxedFreeFunc) nxplot_rect_free);
    return type;
}

NxplotRect* nxplot_rect_new(double x1, double y1, double x2, double y2)
{
    NxplotRect *rv = g_new(NxplotRect, 1);
    rv->x1 = x1; rv->y1 = y1;
    rv->x2 = x2; rv->y2 = y2;
    return rv;
}

/* --- NxplotPoint boxed type --- */

NxplotPoint* nxplot_point_copy(NxplotPoint *point)
{
    NxplotPoint *p;
    p = g_new(NxplotPoint, 1);
    *p = *point;
    return p;
}

void nxplot_point_free(NxplotPoint *point)
{
    g_free(point);
}

GType nxplot_point_get_type(void)
{
    static GType type = 0;
    
    if (type == 0)
	type = g_boxed_type_register_static("NxplotPoint",
					    (GBoxedCopyFunc) nxplot_point_copy,
					    (GBoxedFreeFunc) nxplot_point_free);
    return type;
}

NxplotPoint* nxplot_point_new(double x, double y)
{
    NxplotPoint *rv = g_new(NxplotPoint, 1);
    rv->x = x; rv->y = y;
    return rv;
}


GType nxplot_list_get_type(void)
{
    static GType type = 0;
    
    if (type == 0)
	type = g_boxed_type_register_static("NxplotList",
					    (GBoxedCopyFunc) g_slist_copy,
					    (GBoxedFreeFunc) g_slist_free);
    return type;
}



/**
 * nxplot_setcliprect:
 * @nxplot: plotter
 * @clip_rect: a clipping rectangle. (0, 0, 0, 0) cancels all clipping.
 * 
 * Define a clipping rectangle so that all future drawings are confined to that rectangle. 
 **/
void nxplot_setcliprect(Nxplot *nxplot, NxplotRect *clip_rect)
{
    NxplotClass *class;
    g_return_if_fail(nxplot);
    g_return_if_fail(IS_NXPLOT(nxplot));
    class = NXPLOT_GET_CLASS(nxplot);
    if (class->setcliprect)
	class->setcliprect(nxplot, clip_rect);
    else
	g_warning("setcliprectangle method not implemented by driver");
}


void nxplot_label_metrics_union(NxplotLabelMetrics *result,
				NxplotLabelMetrics *a, NxplotLabelMetrics *b)
{
    result->width         = a->width + b->width;
    result->ascender_max  = MAX(a->ascender_max, b->ascender_max);
    result->descender_max = MAX(a->descender_max, b->descender_max);
    result->ascender      = MAX(a->ascender, b->ascender);
    result->descender     = MAX(a->descender, b->descender);
}



/**
 * nxplot_labelmetrics:
 * @nxplot: plotter
 * @text: text string to measure
 * @metrics: output variable to contain metrics
 * 
 * Return metrics of a given text string.
 **/
void nxplot_labelmetrics (Nxplot             *nxplot,
			  const char         *text,
			  NxplotLabelMetrics *metrics)
{
    NxplotClass *class;
    g_return_if_fail(nxplot);
    g_return_if_fail(IS_NXPLOT(nxplot));
    class = NXPLOT_GET_CLASS(nxplot);
    if (class->labelmetrics)
	class->labelmetrics(nxplot, text, metrics);
    else
	g_warning("labelmetrics method not implemented by driver");
}


void nxplot_fillcolor(Nxplot  *nxplot,
		      guint16  red,
		      guint16  green,
		      guint16  blue)
{
    NxplotClass *class;
    g_return_if_fail(nxplot);
    g_return_if_fail(IS_NXPLOT(nxplot));
    class = NXPLOT_GET_CLASS(nxplot);
    if (class->fillcolor)
	class->fillcolor(nxplot, red, green, blue);
    else
	g_warning("fillcolor method not implemented by driver");
}


void nxplot_fillcolorname(Nxplot *nxplot, const char *name)
{
    NxplotClass *class;
    g_return_if_fail(nxplot);
    g_return_if_fail(IS_NXPLOT(nxplot));
    class = NXPLOT_GET_CLASS(nxplot);
    if (class->fillcolorname)
	class->fillcolorname(nxplot, name);
    else
	g_warning("fillcolorname method not implemented by driver");
}


void nxplot_fillopacity(Nxplot *nxplot, guint16 opacity)
{
    NxplotClass *class;
    g_return_if_fail(nxplot);
    g_return_if_fail(IS_NXPLOT(nxplot));
    class = NXPLOT_GET_CLASS(nxplot);
    if (class->fillopacity)
	class->fillopacity(nxplot, opacity);
    else
	g_warning("fillopacity method not implemented by driver");
}

/* utility function */
void nxplot_box(Nxplot *nxplot, double x1, double y1, double x2, double y2)
{
    nxplot_endpath(nxplot);
    nxplot_line(nxplot, x1, y1, x2, y1);
    nxplot_line(nxplot, x2, y1, x2, y2);
    nxplot_line(nxplot, x2, y2, x1, y2);
    nxplot_line(nxplot, x1, y2, x1, y1);
    nxplot_endpath(nxplot);
}

